#ifndef FOOBAR_H
#define FOOBAR_H

#define  uint8_t int

static int transfer(int _data) ;
static void detachInterrupt(); // Default
static void begin(); // Default
static void end();
static void setBitOrder(uint8_t);
static void setDataMode(uint8_t);
static void setClockDivider(uint8_t);

/////////////////////////////////////////////////////////

extern int SPI_transfer(int _data) ;
extern void SPI_detachInterrupt(); // Default
extern void SPI_begin(); // Default
extern void SPI_end();
extern void SPI_setBitOrder(uint8_t);
extern void SPI_setDataMode(uint8_t);
extern void SPI_setClockDivider(uint8_t);

////////////////////////////////////////////////////////
#define SPI_CLOCK_DIV4 0x00
#define SPI_CLOCK_DIV16 0x01
#define SPI_CLOCK_DIV64 0x02
#define SPI_CLOCK_DIV128 0x03
#define SPI_CLOCK_DIV2 0x04
#define SPI_CLOCK_DIV8 0x05
#define SPI_CLOCK_DIV32 0x06
//#define SPI_CLOCK_DIV64 0x07

#define SPI_MODE0 0x00
#define SPI_MODE1 0x04
#define SPI_MODE2 0x08
#define SPI_MODE3 0x0C

#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR
#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR
#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR

////////////////////////////arduino port
#define spi_transfer (*transfer)
#define spi_attachInterrupt (*attachInterrupt)
#define spi_detachInterrupt (*detachInterrupt)
#define spi_begin (*begin)
#define spi_end (*end)
#define spi_setBitOrder (*setBitOrder)
#define spi_setDataMode (*setDataMode)
#define spi_setClockDivider (*setClockDivider)


typedef struct SPIClass {

//void SPIClass_init();
// SPI Configuration methods
int spi_transfer(int _data);
void spi_attachInterrupt();
void spi_detachInterrupt(); // Default

void spi_begin(); // Default
void spi_end();

void spi_setBitOrder(uint8_t);
void spi_setDataMode(uint8_t);
void spi_setClockDivider(uint8_t);

/// there should be init to initialize the structure
};

 extern struct SPIClass SPI_1;



#endif